<template>
  <v-container>
    <page-title>
      Pacientes
    </page-title>
    <page-content>
      <page-content-list-user>
        <template #buttons>
          <data-button class="mr-2 mt-1" button-name="Agregar" icon="mdi-plus-thick" @clicked="handleClick" />
          <data-button class="mr-2 mt-1" button-name="Plantilla" icon="mdi-file-table-outline" @clicked="handleTemplateClick" />
          <data-button class="mt-1" button-name="Carga masiva" icon="mdi-book-plus-multiple" />
        </template>
        <template #table>
          <search-table
            table-title="Pacientes"
            :full-name="true"
            :headers="headers"
            :items="patients"
            :search="search"
            search-text="Busca un paciente"
            v-on:selectRow="rowSelected"
          />
        </template>
      </page-content-list-user>
    </page-content>
    <table-to-excel :download="downloadTemplate" />
  </v-container>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import PageTitle from '~/components/PageTitle';
import PageContent from '~/components/PageContent';
import PageContentListUser from '~/components/PageContentListUser';
import SearchTable from '~/components/supervisor/SearchTable';
import TableToExcel from '~/components/InputField/TableToExcel';

export default {
  name: 'Patients',
  components: {
    SearchTable,
    PageTitle,
    PageContent,
    PageContentListUser,
    TableToExcel,
  },
  data() {
    return {
      downloadTemplate: false,
      search: '',
      headers: [
        { text: 'Nombres', align: 'start', value: 'full_name', filterable: true },
        { text: 'Tipo de Documento', value: 'user.typeDocument' },
        { text: 'Documento', value: 'user.document' },
        { text: 'Correo', value: 'email' },
        { text: 'Teléfono', value: 'phoneNumber' },
      ],
    };
  },
  computed: {
    ...mapState({
      patients: state => state.clientcompany.patient.patients,
      loading: state => state.clientcompany.patient.loading,
    }),
  },
  async mounted() {
    await this.getAllPatients();
  },
  methods: {
    handleClick() {
      this.$router.push('/pacientes/nuevo-paciente');
    },
    getAllPatients() {
      this.getPatients();
    },
    rowSelected(item, row) {
      this.$router.push(`/pacientes/editar-paciente/${item.uuid}`);
    },
    ...mapActions({
      getPatients: 'clientcompany/patient/getPatients',
    }),
    handleTemplateClick() {
      this.downloadTemplate = true;
    },
  },
};
</script>
